commit 8bb488f93349095c6bf6049c1647243604f409ee
Author: Václav Jirák <jirakv95@gmail.com>
Date:   Thu Apr 25 16:55:12 2019 +0200

    Re #7263 Free days renamed to Off days

diff --git a/frontend/src/app/free-days-approval/free-days-approval.component.html b/frontend/src/app/free-days-approval/free-days-approval.component.html
deleted file mode 100644
index 6180792..0000000
--- a/frontend/src/app/free-days-approval/free-days-approval.component.html
+++ /dev/null
@@ -1,38 +0,0 @@
-<div class="tasks-container">
-
-  <div class="component-header">
-    Schvalování volna
-  </div>
-
-  <div class="tasks-list">
-    <div class="row tasks-header">
-      <div class="col-md-3"> Jméno </div>
-      <div class="col-md-3"> Typ volna </div>
-      <div class="col-md-2"> Od </div>
-      <div class="col-md-2"> Do </div>
-      <div class="col-md-2"></div>
-    </div>
-
-    <div class="row task-container" *ngFor="let task of tasksToComplete">
-      <div class="col-md-3">
-        {{task.username}}
-      </div>
-
-      <div class="col-md-3">
-        {{freeDayTypeToString(task.taskType)}}
-      </div>
-
-      <div class="col-md-2">
-        {{task.dateFrom | date:'yyyy/MM/dd'}}
-      </div>
-      <div class="col-md-2">
-        {{task.dateTo | date:'yyyy/MM/dd'}}
-      </div>
-      <div class="col-md-2">
-        <div class="btn btn-success approve-user-btn" (click)="taskCompleted(task, true)">✓</div>
-        <div class="btn btn-danger reject-user-btn"   (click)="taskCompleted(task, false)">X</div>
-      </div>
-    </div>
-  </div>
-
-</div>
diff --git a/frontend/src/app/free-days-approval/free-days-approval.component.sass b/frontend/src/app/free-days-approval/free-days-approval.component.sass
deleted file mode 100644
index 28fe687..0000000
--- a/frontend/src/app/free-days-approval/free-days-approval.component.sass
+++ /dev/null
@@ -1,18 +0,0 @@
-@import '../../common-styles/basic-component'
-
-.tasks-container
-  @extend .basic-component
-
-  .tasks-header
-    padding: 10px
-    margin: 0
-    font-weight: bold
-
-  .task-container
-    border-bottom: 1px solid gainsboro
-    margin: 0
-    padding: 10px
-    line-height: 35px
-
-    .approve-user-btn
-      margin-right: 2px
diff --git a/frontend/src/app/free-days-approval/free-days-approval.component.ts b/frontend/src/app/free-days-approval/free-days-approval.component.ts
deleted file mode 100644
index 64fd1a3..0000000
--- a/frontend/src/app/free-days-approval/free-days-approval.component.ts
+++ /dev/null
@@ -1,32 +0,0 @@
-import { Component, EventEmitter, Input, OnInit, Output } from '@angular/core';
-import { FreeDaysToApprove } from './free-days-to-approve.model';
-import { FreeDayType } from '../shared/free-day-type';
-
-@Component({
-  selector: 'app-tasks',
-  templateUrl: './free-days-approval.component.html',
-  styleUrls: ['./free-days-approval.component.sass']
-})
-export class FreeDaysApprovalComponent implements OnInit {
-
-  @Input()  tasksToComplete: FreeDaysToApprove[];
-  @Output() taskCompletedAction = new EventEmitter<{task: FreeDaysToApprove, approved: boolean}>();
-
-  constructor() { }
-
-  ngOnInit() {
-  }
-
-  taskCompleted(completedTask: FreeDaysToApprove, isApproved: boolean ) {
-    this.taskCompletedAction.emit({task: completedTask, approved: isApproved});
-  }
-
-  private freeDayTypeToString(taskType: FreeDayType): string {
-    switch (taskType) {
-      case FreeDayType.ExtraVacation:
-        return 'Extra dovolená';
-      case FreeDayType.Sickday:
-        return 'Sickdays';
-    }
-  }
-}
diff --git a/frontend/src/app/free-days-approval/free-days-approval.module.ts b/frontend/src/app/free-days-approval/free-days-approval.module.ts
deleted file mode 100644
index 05a6008..0000000
--- a/frontend/src/app/free-days-approval/free-days-approval.module.ts
+++ /dev/null
@@ -1,10 +0,0 @@
-import { NgModule } from '@angular/core';
-import { FreeDaysApprovalComponent } from './free-days-approval.component';
-import { BrowserModule } from '@angular/platform-browser';
-
-@NgModule({
-  declarations: [ FreeDaysApprovalComponent ],
-  exports:      [ FreeDaysApprovalComponent ],
-  imports:      [ BrowserModule ]
-})
-export class FreeDaysApprovalModule { }
diff --git a/frontend/src/app/free-days-approval/free-days-to-approve.model.ts b/frontend/src/app/free-days-approval/free-days-to-approve.model.ts
deleted file mode 100644
index b139e04..0000000
--- a/frontend/src/app/free-days-approval/free-days-to-approve.model.ts
+++ /dev/null
@@ -1,8 +0,0 @@
-import { FreeDayType } from '../shared/free-day-type';
-
-export class FreeDaysToApprove {
-  username: string;
-  dateFrom: Date;
-  dateTo: Date;
-  taskType: FreeDayType;
-}
diff --git a/frontend/src/app/off-days-approval/off-days-approval.component.html b/frontend/src/app/off-days-approval/off-days-approval.component.html
new file mode 100644
index 0000000..6180792
--- /dev/null
+++ b/frontend/src/app/off-days-approval/off-days-approval.component.html
@@ -0,0 +1,38 @@
+<div class="tasks-container">
+
+  <div class="component-header">
+    Schvalování volna
+  </div>
+
+  <div class="tasks-list">
+    <div class="row tasks-header">
+      <div class="col-md-3"> Jméno </div>
+      <div class="col-md-3"> Typ volna </div>
+      <div class="col-md-2"> Od </div>
+      <div class="col-md-2"> Do </div>
+      <div class="col-md-2"></div>
+    </div>
+
+    <div class="row task-container" *ngFor="let task of tasksToComplete">
+      <div class="col-md-3">
+        {{task.username}}
+      </div>
+
+      <div class="col-md-3">
+        {{freeDayTypeToString(task.taskType)}}
+      </div>
+
+      <div class="col-md-2">
+        {{task.dateFrom | date:'yyyy/MM/dd'}}
+      </div>
+      <div class="col-md-2">
+        {{task.dateTo | date:'yyyy/MM/dd'}}
+      </div>
+      <div class="col-md-2">
+        <div class="btn btn-success approve-user-btn" (click)="taskCompleted(task, true)">✓</div>
+        <div class="btn btn-danger reject-user-btn"   (click)="taskCompleted(task, false)">X</div>
+      </div>
+    </div>
+  </div>
+
+</div>
diff --git a/frontend/src/app/off-days-approval/off-days-approval.component.sass b/frontend/src/app/off-days-approval/off-days-approval.component.sass
new file mode 100644
index 0000000..28fe687
--- /dev/null
+++ b/frontend/src/app/off-days-approval/off-days-approval.component.sass
@@ -0,0 +1,18 @@
+@import '../../common-styles/basic-component'
+
+.tasks-container
+  @extend .basic-component
+
+  .tasks-header
+    padding: 10px
+    margin: 0
+    font-weight: bold
+
+  .task-container
+    border-bottom: 1px solid gainsboro
+    margin: 0
+    padding: 10px
+    line-height: 35px
+
+    .approve-user-btn
+      margin-right: 2px
diff --git a/frontend/src/app/off-days-approval/off-days-approval.component.ts b/frontend/src/app/off-days-approval/off-days-approval.component.ts
new file mode 100644
index 0000000..658f39c
--- /dev/null
+++ b/frontend/src/app/off-days-approval/off-days-approval.component.ts
@@ -0,0 +1,32 @@
+import { Component, EventEmitter, Input, OnInit, Output } from '@angular/core';
+import { OffDaysToApprove } from './off-days-to-approve.model';
+import { OffDayType } from '../shared/off-day-type';
+
+@Component({
+  selector: 'app-tasks',
+  templateUrl: './off-days-approval.component.html',
+  styleUrls: ['./off-days-approval.component.sass']
+})
+export class OffDaysApprovalComponent implements OnInit {
+
+  @Input()  tasksToComplete: OffDaysToApprove[];
+  @Output() taskCompletedAction = new EventEmitter<{task: OffDaysToApprove, approved: boolean}>();
+
+  constructor() { }
+
+  ngOnInit() {
+  }
+
+  taskCompleted(completedTask: OffDaysToApprove, isApproved: boolean ) {
+    this.taskCompletedAction.emit({task: completedTask, approved: isApproved});
+  }
+
+  private freeDayTypeToString(taskType: OffDayType): string {
+    switch (taskType) {
+      case OffDayType.ExtraVacation:
+        return 'Extra dovolená';
+      case OffDayType.Sickday:
+        return 'Sickdays';
+    }
+  }
+}
diff --git a/frontend/src/app/off-days-approval/off-days-approval.module.ts b/frontend/src/app/off-days-approval/off-days-approval.module.ts
new file mode 100644
index 0000000..d9bb1f6
--- /dev/null
+++ b/frontend/src/app/off-days-approval/off-days-approval.module.ts
@@ -0,0 +1,10 @@
+import { NgModule } from '@angular/core';
+import { OffDaysApprovalComponent } from './off-days-approval.component';
+import { BrowserModule } from '@angular/platform-browser';
+
+@NgModule({
+  declarations: [ OffDaysApprovalComponent ],
+  exports:      [ OffDaysApprovalComponent ],
+  imports:      [ BrowserModule ]
+})
+export class OffDaysApprovalModule { }
diff --git a/frontend/src/app/off-days-approval/off-days-to-approve.model.ts b/frontend/src/app/off-days-approval/off-days-to-approve.model.ts
new file mode 100644
index 0000000..87a6e96
--- /dev/null
+++ b/frontend/src/app/off-days-approval/off-days-to-approve.model.ts
@@ -0,0 +1,8 @@
+import { OffDayType } from '../shared/off-day-type';
+
+export class OffDaysToApprove {
+  username: string;
+  dateFrom: Date;
+  dateTo: Date;
+  taskType: OffDayType;
+}
diff --git a/frontend/src/app/shared/free-day-type.ts b/frontend/src/app/shared/free-day-type.ts
deleted file mode 100644
index bdc966c..0000000
--- a/frontend/src/app/shared/free-day-type.ts
+++ /dev/null
@@ -1,4 +0,0 @@
-export enum FreeDayType {
-  ExtraVacation,
-  Sickday
-}
diff --git a/frontend/src/app/shared/off-day-type.ts b/frontend/src/app/shared/off-day-type.ts
new file mode 100644
index 0000000..dcb832b
--- /dev/null
+++ b/frontend/src/app/shared/off-day-type.ts
@@ -0,0 +1,4 @@
+export enum OffDayType {
+  ExtraVacation,
+  Sickday
+}