commit 93fb36952ad751a0db9081e8557fb376374a5a20
Author: Václav Jirák <jirakv95@gmail.com>
Date:   Wed Jun 5 11:59:03 2019 +0200

    sickday refactored to sickDay

diff --git a/webapp/src/app/dashboard/employer-dashboard/employer-dashboard.component.html b/webapp/src/app/dashboard/employer-dashboard/employer-dashboard.component.html
index 2c61293..d2f7113 100644
--- a/webapp/src/app/dashboard/employer-dashboard/employer-dashboard.component.html
+++ b/webapp/src/app/dashboard/employer-dashboard/employer-dashboard.component.html
@@ -39,7 +39,7 @@
 
       <div class="days-off-info" *ngIf="profile">
         <app-vacation-info
-          [sickDaysRemaining]="profile.sickdayCount"
+          [sickDaysRemaining]="profile.sickDayCount"
           [extraVacationRemaining]="profile.vacationCount"
         ></app-vacation-info>
       </div>
diff --git a/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.html b/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.html
index 9cf0f5e..ee3ff9a 100644
--- a/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.html
+++ b/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.html
@@ -7,7 +7,7 @@
   <div class="sickday-count">
     <label for="sickdays-count-input" class="dialog-label">Počet sickdays:</label>
     <mat-form-field>
-      <input id="sickdays-count-input" type="number" matInput [(ngModel)]="data.sickdaysCount">
+      <input id="sickdays-count-input" type="number" matInput [(ngModel)]="data.sickDayCount">
     </mat-form-field>
   </div>
 </div>
diff --git a/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.ts b/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.ts
index 9fd66d1..1dc68d9 100644
--- a/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.ts
+++ b/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.ts
@@ -19,7 +19,7 @@ export class DefaultSettingsDialogComponent {
     this.dialogRef.close({
       isConfirmed: true,
       notificationDatetime: this.toNotificationDatetime(),
-      sickdayCount: this.data.sickdaysCount
+      sickDayCount: this.data.sickDayCount
     });
   }
 
@@ -46,5 +46,5 @@ export class DefaultSettingsDialogComponent {
 export class DefaultSettingsDialogData {
   notificationDate: Date;
   notificationTime: string;
-  sickdaysCount: number;
+  sickDayCount: number;
 }
diff --git a/webapp/src/app/employees/edit-employee-dialog/edit-employee-dialog.component.ts b/webapp/src/app/employees/edit-employee-dialog/edit-employee-dialog.component.ts
index b3ab6aa..8aa2f37 100644
--- a/webapp/src/app/employees/edit-employee-dialog/edit-employee-dialog.component.ts
+++ b/webapp/src/app/employees/edit-employee-dialog/edit-employee-dialog.component.ts
@@ -21,7 +21,7 @@ export class EditEmployeeDialogComponent implements OnInit {
   constructor(public dialogRef: MatDialogRef<EditEmployeeDialogComponent>,
               @Inject(MAT_DIALOG_DATA) public data: UserProfile,
               private snackBar: MatSnackBar) {
-    this._sickDaysCount = data.sickdayCount;
+    this._sickDaysCount = data.sickDayCount;
     this._vacationDaysCount = data.vacationCount;
     this._userType = data.role;
     this._userId = data.id;
@@ -37,7 +37,7 @@ export class EditEmployeeDialogComponent implements OnInit {
       this.postUserSettings.emit({
         id: this._userId,
         role: this._userType,
-        sickdayCount: this._sickDaysCount,
+        sickDayCount: this._sickDaysCount,
         vacationCount: this._vacationDaysCount
       });
 
diff --git a/webapp/src/app/employees/employees-list.component.ts b/webapp/src/app/employees/employees-list.component.ts
index f8bec7f..7d1ef0d 100644
--- a/webapp/src/app/employees/employees-list.component.ts
+++ b/webapp/src/app/employees/employees-list.component.ts
@@ -123,7 +123,7 @@ export class EmployeesListComponent implements OnInit {
           const parsedSettings = {
             notificationDate: new Date(parsedDate.getFullYear(), parsedDate.getMonth(), parsedDate.getDate()),
             notificationTime: parsedDate.getHours() + ':' + parsedDate.getMinutes(),
-            sickdaysCount: settingsData.sickdayCount
+            sickdaysCount: settingsData.sickDayCount
           };
 
           this.dialog.open(DefaultSettingsDialogComponent, {
@@ -142,7 +142,7 @@ export class EmployeesListComponent implements OnInit {
 
   private toSettings(data): Settings {
     return {
-      sickdayCount: data.sickdayCount,
+      sickDayCount: data.sickDayCount,
       notification: this.dateFormatterService.formatDatetime(data.notificationDatetime)
     };
   }
diff --git a/webapp/src/app/employees/user-profile/user-profile-dialog.component.html b/webapp/src/app/employees/user-profile/user-profile-dialog.component.html
index 3ed2868..1c5366a 100644
--- a/webapp/src/app/employees/user-profile/user-profile-dialog.component.html
+++ b/webapp/src/app/employees/user-profile/user-profile-dialog.component.html
@@ -12,7 +12,7 @@
         <span class="user-name">{{profile.firstName}} {{profile.lastName}}</span>
       </div>
       <app-vacation-info
-        [sickDaysRemaining]="profile.sickdayCount"
+        [sickDaysRemaining]="profile.sickDayCount"
         [extraVacationRemaining]="profile.vacationCount"
       ></app-vacation-info>
     </div>
diff --git a/webapp/src/app/enums/common.enum.ts b/webapp/src/app/enums/common.enum.ts
index 27bf64c..08977b2 100644
--- a/webapp/src/app/enums/common.enum.ts
+++ b/webapp/src/app/enums/common.enum.ts
@@ -17,7 +17,7 @@ export enum ProfileStatus {
 
 export enum VacationType {
   VACATION = 'VACATION',
-  SICKDAY = 'SICKDAY',
+  SICKDAY = 'SICK_DAY',
   NONE = 'NONE',
 }
 
diff --git a/webapp/src/app/models/settings.model.ts b/webapp/src/app/models/settings.model.ts
index 1a6b806..2e3b66a 100644
--- a/webapp/src/app/models/settings.model.ts
+++ b/webapp/src/app/models/settings.model.ts
@@ -1,14 +1,14 @@
 import {UserType} from '../enums/common.enum';
 
 export interface Settings {
-  sickdayCount: number;
+  sickDayCount: number;
   notification: string;
 }
 
 export interface UserSettings {
   id: number;
   vacationCount: number;
-  sickdayCount: number;
+  sickDayCount: number;
   role: UserType;
 }
 
diff --git a/webapp/src/app/models/user.model.ts b/webapp/src/app/models/user.model.ts
index 5285d8c..30b4bde 100644
--- a/webapp/src/app/models/user.model.ts
+++ b/webapp/src/app/models/user.model.ts
@@ -23,7 +23,7 @@ export interface UserProfile {
   lastName: string;
   photo: string;
   vacationCount: number;
-  sickdayCount: number;
+  sickDayCount: number;
   status: RequestStatus;
   role: UserType;
   notification: Date;
diff --git a/webapp/src/app/services/tests/settings.service.spec.ts b/webapp/src/app/services/tests/settings.service.spec.ts
index 8c4b84c..32075fb 100644
--- a/webapp/src/app/services/tests/settings.service.spec.ts
+++ b/webapp/src/app/services/tests/settings.service.spec.ts
@@ -23,13 +23,13 @@ describe('SettingsService', () => {
 
   it('getDefaultSettings', () => {
     const dummyData = {
-      sickdayCount: 3,
+      sickDayCount: 3,
       notification: '2019/05/25 14:41:31'
     };
 
     service.getDefaultSettings().subscribe((data: any) => {
-      expect(data.sickdayCount).toBeDefined();
-      expect(data.sickdayCount).toBe(3);
+      expect(data.sickDayCount).toBeDefined();
+      expect(data.sickDayCount).toBe(3);
       expect(data.notification).toBeDefined();
     });
 
@@ -40,13 +40,13 @@ describe('SettingsService', () => {
 
   it('getDefaultSettingsWithLanguage', () => {
     const dummyData = {
-      sickdayCount: 3,
+      sickDayCount: 3,
       notification: '2019/05/25 14:41:31'
     };
 
     service.getDefaultSettingsWithLanguage(Languages.ENGLISH).subscribe((data: any) => {
-      expect(data.sickdayCount).toBeDefined();
-      expect(data.sickdayCount).toBe(3);
+      expect(data.sickDayCount).toBeDefined();
+      expect(data.sickDayCount).toBe(3);
       expect(data.notification).toBeDefined();
     });
 
@@ -61,7 +61,7 @@ describe('SettingsService', () => {
       answer: 'ok',
     };
 
-    service.postDefaultSettings({sickdayCount: 3, notification: '2019/04/25 18:23:36'})
+    service.postDefaultSettings({sickDayCount: 3, notification: '2019/04/25 18:23:36'})
       .subscribe((data: any) => expect(data.answer).toBe('ok'));
 
     const req = httpMock.expectOne(baseUrl + '/api/settings');
@@ -74,7 +74,7 @@ describe('SettingsService', () => {
       answer: 'ok',
     };
 
-    service.postDefaultSettingsWithLanguage({sickdayCount: 3, notification: '2019/04/25 18:23:36'}, Languages.ENGLISH)
+    service.postDefaultSettingsWithLanguage({sickDayCount: 3, notification: '2019/04/25 18:23:36'}, Languages.ENGLISH)
       .subscribe((data: any) => expect(data.answer).toBe('ok'));
 
     const req = httpMock.expectOne(baseUrl + '/api/settings?lang=EN');
diff --git a/webapp/src/app/services/tests/user.service.spec.ts b/webapp/src/app/services/tests/user.service.spec.ts
index e6b68b7..3b7dd41 100644
--- a/webapp/src/app/services/tests/user.service.spec.ts
+++ b/webapp/src/app/services/tests/user.service.spec.ts
@@ -28,7 +28,7 @@ describe('UsersService', () => {
       lastName: 'Novak',
       photo: 'https://st2.depositphotos.com/9223672/12056/v/950/depositphotos_120568236-stock-illustration-male-face-avatar-logo-template.jpg',
       vacationCount: 8.5,
-      sickdayCount: 3,
+      sickDayCount: 3,
       status: 'ACCEPTED',
       role: 'EMPLOYER',
       notification: '2000/12/01 09:00:00'
@@ -38,7 +38,7 @@ describe('UsersService', () => {
     service.getLoggedUserProfile().subscribe((data: any) => {
       expect(data.id).toBe(1);
       expect(data.vacationCount).toBe(8.5);
-      expect(data.sickdayCount).toBe(3);
+      expect(data.sickDayCount).toBe(3);
       expect(data.status).toBe(RequestStatus.ACCEPTED);
       expect(data.role).toBe(UserType.EMPLOYER);
       expect(data.notification).toBeDefined();
@@ -56,7 +56,7 @@ describe('UsersService', () => {
       lastName: 'Novak',
       photo: 'https://st2.depositphotos.com/9223672/12056/v/950/depositphotos_120568236-stock-illustration-male-face-avatar-logo-template.jpg',
       vacationCount: 8.5,
-      sickdayCount: 3,
+      sickDayCount: 3,
       status: 'ACCEPTED',
       role: 'EMPLOYER',
       notification: '2000/12/01 09:00:00'
@@ -66,7 +66,7 @@ describe('UsersService', () => {
     service.getLoggedUserProfileWithLanguage(Languages.ENGLISH).subscribe((data: any) => {
       expect(data.id).toBe(1);
       expect(data.vacationCount).toBe(8.5);
-      expect(data.sickdayCount).toBe(3);
+      expect(data.sickDayCount).toBe(3);
       expect(data.status).toBe(RequestStatus.ACCEPTED);
       expect(data.role).toBe(UserType.EMPLOYER);
       expect(data.notification).toBeDefined();